import { Status, MessageFrame } from '@viae/core';
/**
 * message
 */
export interface Message<T = any> extends MessageFrame {
    data?: T;
}
export interface Response<Body = any> extends Message<Body> {
    data?: Body;
    head: {
        status: Status;
    };
}
export interface Request<Body = any> extends Message<Body> {
    head: {
        path: string;
        method: string;
    };
}
export declare function isRequest<T>(message: Partial<Message<T>>): message is Request<T>;
export declare function isResponse<T>(message: Partial<Message<T>>): message is Request<T>;
