import { Middleware, Next, Processor } from 'rowan';
import { Context } from '../context';
import { MessageHeader } from '@viae/core';
import { Router } from './router';
export interface HandlerOptions<D, C extends Context = Context> {
    data: D;
    head: MessageHeader;
    raw: Uint8Array;
    path: string;
    ctx: C;
    params: Record<string, string>;
    next?: Next;
}
export type ApiAcceptOptions = {
    type: "object" | "stream";
};
export type ApiRouteOptions<R, A extends "stream" | "object", C extends Context = Context> = {
    path: string;
    end?: true;
    next?: true;
    accept?: A;
    validate?(value: any): asserts value is R;
    handler: (opt: HandlerOptions<A extends "stream" ? ReadableStream<R> : R, C>) => any;
};
export type ApiFn = <R, A extends "stream" | "object">(opts: ApiRouteOptions<R, A>) => void;
export declare class Api<C extends Context = Context> extends Router {
    constructor(root?: string);
    all: ApiFn;
    get: ApiFn;
    post: ApiFn;
    put: ApiFn;
    delete: ApiFn;
    subscribe: ApiFn;
    use(processor: Processor<C>): any;
    use(path: string, api: Middleware<C>): any;
}
