"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Adds a Lazy data decoder to the incoming message
 */
class BodyDecoder {
    _codex;
    constructor(_codex) {
        this._codex = _codex;
        if (_codex == null) {
            throw Error("body decoder must be initialized with a codex");
        }
    }
    meta;
    process(ctx, next) {
        if (ctx["__decoded"] === true || !ctx.in || !ctx.in.head || !ctx.in.raw)
            return next();
        const codex = this._codex;
        Object.defineProperty(ctx.in, "data", {
            configurable: true,
            get: function () {
                delete ctx.in.data;
                let encoder = codex[ctx.in.head.encoding];
                if (encoder) {
                    ctx.in.data = encoder.decode(ctx.in.raw);
                    ctx["__decoded"] = true;
                }
                return ctx.in.data;
            }
        });
        return next();
    }
}
exports.default = BodyDecoder;
