"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Encodes the outgoing message data
 */
class BodyEncoder {
    _codex;
    defaultEncoding;
    constructor(_codex, defaultEncoding = "msgpack") {
        this._codex = _codex;
        this.defaultEncoding = defaultEncoding;
        if (_codex == null) {
            throw Error("body encoder must be initialized with a codex");
        }
    }
    meta;
    process(ctx, next) {
        if (ctx["__encoded"] === true || !ctx.out || ctx.out.data === undefined || !ctx.out.head)
            return next();
        if (ctx.out.head.encoding == undefined) {
            if (ctx.out.data instanceof Uint8Array) {
                ctx.out.raw = ctx.out.data;
                ctx.out.head.encoding = "none";
                ctx["__encoded"] = true;
            }
            else {
                ctx.out.head.encoding = this.defaultEncoding;
            }
        }
        let encoder = this._codex[ctx.out.head.encoding];
        if (encoder) {
            ctx.out.raw = encoder.encode(ctx.out.data);
            ctx["__encoded"] = true;
        }
        return next();
    }
}
exports.default = BodyEncoder;
