"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.request = request;
const path_to_regexp_1 = require("path-to-regexp");
/* the message is a request with a path matching the parameter */
function request(method, path) {
    if (method != undefined && path != undefined) {
        let keys = [];
        var exp = (0, path_to_regexp_1.pathToRegexp)(path, keys);
        return (ctx) => {
            if (ctx.in == undefined || ctx.in.head == undefined || ctx.in.head.method !== method)
                return Promise.resolve(false);
            let match = (ctx.in.head.path) ? exp.exec(ctx.in.head.path) : null;
            if (match == null) {
                return Promise.resolve(false);
            }
            if (keys.length > 0) {
                ctx.params = ctx.params || {};
                for (let i = 0; i < keys.length; i += 1) {
                    ctx.params[keys[i].name] = match[i + 1];
                }
            }
            return Promise.resolve(true);
        };
    }
    else if (method != undefined) {
        return (ctx) => {
            return Promise.resolve(ctx.in != undefined && ctx.in.head != undefined && ctx.in.head.method === method);
        };
    }
    return (ctx) => {
        return Promise.resolve(ctx.in != undefined);
    };
}
