import { Processor, Middleware, Next, Meta } from 'rowan';
import { Context } from '../context';
export interface RouterOptions {
    /** route root path */
    root?: string;
    /** route descriptive name */
    name?: string;
    /** route documentation */
    doc?: string;
    middleware?: Middleware<Context>[];
}
export declare class Router implements Middleware<Context>, RouterOptions {
    /** route base path  */
    root: string;
    /** route descriptive name */
    name: string;
    /** route documentation */
    doc: string;
    /** route middleware */
    middleware: Middleware<Context>[];
    meta: Meta;
    private _rootMatch;
    constructor(opts?: RouterOptions);
    process(ctx: Context, next: Next): Promise<void>;
    use(processor: Processor<Context>, meta?: Meta): void;
    route(opts: {
        path: string;
        method: string;
        process: Processor<Context>[];
        name?: string;
        doc?: string;
        end?: boolean;
    }): void;
}
