"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Codex = void 0;
exports.textToBytes = textToBytes;
exports.bytesToText = bytesToText;
const cbor_x_1 = require("cbor-x");
const msgpackr_1 = require("msgpackr");
var Codex;
(function (Codex) {
    function createDefault() {
        return {
            "msgpack": {
                encode: msgpackr_1.pack,
                decode: msgpackr_1.unpack
            },
            "cbor": {
                encode: cbor_x_1.encode,
                decode: cbor_x_1.decode
            },
            "json": {
                encode: function (x) { return textToBytes(JSON.stringify(x)); },
                decode: function (x) { return JSON.parse(bytesToText(x)); }
            },
            "none": {
                encode(value) { return value; },
                decode(value) { return value; }
            }
        };
    }
    Codex.createDefault = createDefault;
})(Codex || (exports.Codex = Codex = {}));
const encoder = new TextEncoder();
const decoder = new TextDecoder();
function textToBytes(s) {
    return encoder.encode(s);
}
;
function bytesToText(ua) {
    return decoder.decode(ua);
}
;
